﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace AnotherToolTipTest
{
    public class MyTooltip : ToolTip
    {
        private Font m_font = null;

        public MyTooltip(Font font)
            : base()
        {
            m_font = font;

            this.OwnerDraw = true;
            this.Draw += new DrawToolTipEventHandler(OnDraw);
            this.Popup += new PopupEventHandler(OnPopup);
        }

        protected override void Dispose(bool disposing)
        {
            this.Draw -= new DrawToolTipEventHandler(OnDraw);
            this.Popup -= new PopupEventHandler(OnPopup);
            base.Dispose(disposing);
        }

        public new bool IsBalloon
        {
            set { ; }
            get { return base.IsBalloon; }
        }

        private void OnPopup(object sender, PopupEventArgs e)
        {
            SizeF size = e.AssociatedControl.CreateGraphics().MeasureString(this.GetToolTip(e.AssociatedControl), m_font);
            e.ToolTipSize = new Size(Convert.ToInt32(size.Width), Convert.ToInt32(size.Height));
        }

        private void OnDraw(object sender, DrawToolTipEventArgs e)
        {
            DrawToolTipEventArgs newArgs = new DrawToolTipEventArgs(e.Graphics,
                e.AssociatedWindow, e.AssociatedControl, e.Bounds, e.ToolTipText,
                this.BackColor, this.ForeColor, m_font);

            newArgs.DrawBackground();
            newArgs.DrawBorder();
            newArgs.DrawText(TextFormatFlags.TextBoxControl);
        }
    }
}
